=begin
#Pipedrive API v1

#No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module Pipedrive
  class MailMessagesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Get one mail message
    # Returns data about specific mail message.
    # @param id [Integer] ID of the mail message to fetch.
    # @param [Hash] opts the optional parameters
    # @option opts [NumberBooleanDefault0] :include_body Whether to include full message body or not. 0 &#x3D; Don&#39;t include, 1 &#x3D; Include
    # @return [MailMessage]
    def mailbox_mail_messages_id_get(id, opts = {})
      data, _status_code, _headers = mailbox_mail_messages_id_get_with_http_info(id, opts)
      data
    end

    # Get one mail message
    # Returns data about specific mail message.
    # @param id [Integer] ID of the mail message to fetch.
    # @param [Hash] opts the optional parameters
    # @option opts [NumberBooleanDefault0] :include_body Whether to include full message body or not. 0 &#x3D; Don&#39;t include, 1 &#x3D; Include
    # @return [Array<(MailMessage, Integer, Hash)>] MailMessage data, response status code and response headers
    def mailbox_mail_messages_id_get_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: MailMessagesApi.mailbox_mail_messages_id_get ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling MailMessagesApi.mailbox_mail_messages_id_get"
      end
      # resource path
      local_var_path = '/mailbox/mailMessages/{id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'include_body'] = opts[:'include_body'] if !opts[:'include_body'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'MailMessage' 

      # auth_names
      auth_names = opts[:auth_names] || ['api_key', 'oauth2']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: MailMessagesApi#mailbox_mail_messages_id_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
