=begin
#Pipedrive API v1

#No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module Pipedrive
  class Activity
    # Subject of the activity
    attr_accessor :subject

    attr_accessor :done

    # Type of the activity. This is in correlation with the key_string parameter of ActivityTypes.
    attr_accessor :type

    # Due date of the activity. Format: YYYY-MM-DD
    attr_accessor :due_date

    # Due time of the activity in UTC. Format: HH:MM
    attr_accessor :due_time

    # Duration of the activity. Format: HH:MM
    attr_accessor :duration

    # ID of the user whom the activity will be assigned to. If omitted, the activity will be assigned to the authorized user.
    attr_accessor :user_id

    # ID of the deal this activity will be associated with
    attr_accessor :deal_id

    # ID of the person this activity will be associated with
    attr_accessor :person_id

    # List of multiple persons (participants) this activity will be associated with. If omitted, single participant from person_id field is used. It requires a structure as follows: [{\"person_id\":1,\"primary_flag\":true}]
    attr_accessor :participants

    # ID of the organization this activity will be associated with
    attr_accessor :org_id

    # Note of the activity (HTML format)
    attr_accessor :note

    # The address of the activity. Pipedrive will automatically check if the location matches a geo-location on Google maps.
    attr_accessor :location

    # Additional details about the activity that will be synced to your external calendar. Unlike the note added to the activity, the description will be publicly visible to any guests added to the activity.
    attr_accessor :public_description

    # Set the activity as 'Busy' or 'Free'. If the flag is set to true, your customers will not be able to book that time slot through any Scheduler links. The flag can also be unset by never setting it or overriding it with null. When the value of the flag is unset (null), the flag defaults to 'Busy' if it has a time set, and 'Free' if it is an all-day event without specified time.
    attr_accessor :busy_flag

    # Attendees of the activity. This can be either your existing Pipedrive contacts or an external email address. It requires a structure as follows: [{\"email_address\":\"mail@example.org\"}] or [{\"person_id\":1, \"email_address\":\"mail@example.org\"}]
    attr_accessor :attendees

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'subject' => :'subject',
        :'done' => :'done',
        :'type' => :'type',
        :'due_date' => :'due_date',
        :'due_time' => :'due_time',
        :'duration' => :'duration',
        :'user_id' => :'user_id',
        :'deal_id' => :'deal_id',
        :'person_id' => :'person_id',
        :'participants' => :'participants',
        :'org_id' => :'org_id',
        :'note' => :'note',
        :'location' => :'location',
        :'public_description' => :'public_description',
        :'busy_flag' => :'busy_flag',
        :'attendees' => :'attendees'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'subject' => :'String',
        :'done' => :'NumberBoolean',
        :'type' => :'String',
        :'due_date' => :'Date',
        :'due_time' => :'String',
        :'duration' => :'String',
        :'user_id' => :'Integer',
        :'deal_id' => :'Integer',
        :'person_id' => :'Integer',
        :'participants' => :'Array<Object>',
        :'org_id' => :'Integer',
        :'note' => :'String',
        :'location' => :'String',
        :'public_description' => :'String',
        :'busy_flag' => :'Boolean',
        :'attendees' => :'Array<Object>'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Pipedrive::Activity` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Pipedrive::Activity`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'subject')
        self.subject = attributes[:'subject']
      end

      if attributes.key?(:'done')
        self.done = attributes[:'done']
      end

      if attributes.key?(:'type')
        self.type = attributes[:'type']
      end

      if attributes.key?(:'due_date')
        self.due_date = attributes[:'due_date']
      end

      if attributes.key?(:'due_time')
        self.due_time = attributes[:'due_time']
      end

      if attributes.key?(:'duration')
        self.duration = attributes[:'duration']
      end

      if attributes.key?(:'user_id')
        self.user_id = attributes[:'user_id']
      end

      if attributes.key?(:'deal_id')
        self.deal_id = attributes[:'deal_id']
      end

      if attributes.key?(:'person_id')
        self.person_id = attributes[:'person_id']
      end

      if attributes.key?(:'participants')
        if (value = attributes[:'participants']).is_a?(Array)
          self.participants = value
        end
      end

      if attributes.key?(:'org_id')
        self.org_id = attributes[:'org_id']
      end

      if attributes.key?(:'note')
        self.note = attributes[:'note']
      end

      if attributes.key?(:'location')
        self.location = attributes[:'location']
      end

      if attributes.key?(:'public_description')
        self.public_description = attributes[:'public_description']
      end

      if attributes.key?(:'busy_flag')
        self.busy_flag = attributes[:'busy_flag']
      end

      if attributes.key?(:'attendees')
        if (value = attributes[:'attendees']).is_a?(Array)
          self.attendees = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @subject.nil?
        invalid_properties.push('invalid value for "subject", subject cannot be nil.')
      end

      if @type.nil?
        invalid_properties.push('invalid value for "type", type cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @subject.nil?
      return false if @type.nil?
      busy_flag_validator = EnumAttributeValidator.new('Boolean', ["true", "false"])
      return false unless busy_flag_validator.valid?(@busy_flag)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] busy_flag Object to be assigned
    def busy_flag=(busy_flag)
      validator = EnumAttributeValidator.new('Boolean', ["true", "false"])
      unless validator.valid?(busy_flag)
        fail ArgumentError, "invalid value for \"busy_flag\", must be one of #{validator.allowable_values}."
      end
      @busy_flag = busy_flag
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          subject == o.subject &&
          done == o.done &&
          type == o.type &&
          due_date == o.due_date &&
          due_time == o.due_time &&
          duration == o.duration &&
          user_id == o.user_id &&
          deal_id == o.deal_id &&
          person_id == o.person_id &&
          participants == o.participants &&
          org_id == o.org_id &&
          note == o.note &&
          location == o.location &&
          public_description == o.public_description &&
          busy_flag == o.busy_flag &&
          attendees == o.attendees
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [subject, done, type, due_date, due_time, duration, user_id, deal_id, person_id, participants, org_id, note, location, public_description, busy_flag, attendees].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Pipedrive.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
