=begin
#Pipedrive API v1

#No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module Pipedrive
  class BaseMailThreadAllOf
    attr_accessor :parties

    # Parties of the drafted mail thread
    attr_accessor :drafts_parties

    # Folders in which messages from thread are being stored
    attr_accessor :folders

    # Version
    attr_accessor :version

    # A snippet from a draft
    attr_accessor :snippet_draft

    # A snippet from a message sent
    attr_accessor :snippet_sent

    # An amount of messages
    attr_accessor :message_count

    # Whether the mail thread has any drafts
    attr_accessor :has_draft_flag

    # Whether the mail thread has messages sent
    attr_accessor :has_sent_flag

    attr_accessor :archived_flag

    # Whether the mail thread is shared
    attr_accessor :shared_flag

    # Whether the mail thread has been deleted externally
    attr_accessor :external_deleted_flag

    # Whether the mail thread was initialized by others
    attr_accessor :first_message_to_me_flag

    # Last message timestamp
    attr_accessor :last_message_timestamp

    # The time when the mail thread has had the first message received or created
    attr_accessor :first_message_timestamp

    # The last time when the mail thread has had a message sent
    attr_accessor :last_message_sent_timestamp

    # The last time when the mail thread has had a message received
    attr_accessor :last_message_received_timestamp

    # The time when the mail thread was inserted to database
    attr_accessor :add_time

    # The time when the mail thread was updated in database received
    attr_accessor :update_time

    # ID of the deal
    attr_accessor :deal_id

    # Status of the deal
    attr_accessor :deal_status

    # Whether all the mail thread messages have been sent
    attr_accessor :all_messages_sent_flag

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'parties' => :'parties',
        :'drafts_parties' => :'drafts_parties',
        :'folders' => :'folders',
        :'version' => :'version',
        :'snippet_draft' => :'snippet_draft',
        :'snippet_sent' => :'snippet_sent',
        :'message_count' => :'message_count',
        :'has_draft_flag' => :'has_draft_flag',
        :'has_sent_flag' => :'has_sent_flag',
        :'archived_flag' => :'archived_flag',
        :'shared_flag' => :'shared_flag',
        :'external_deleted_flag' => :'external_deleted_flag',
        :'first_message_to_me_flag' => :'first_message_to_me_flag',
        :'last_message_timestamp' => :'last_message_timestamp',
        :'first_message_timestamp' => :'first_message_timestamp',
        :'last_message_sent_timestamp' => :'last_message_sent_timestamp',
        :'last_message_received_timestamp' => :'last_message_received_timestamp',
        :'add_time' => :'add_time',
        :'update_time' => :'update_time',
        :'deal_id' => :'deal_id',
        :'deal_status' => :'deal_status',
        :'all_messages_sent_flag' => :'all_messages_sent_flag'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'parties' => :'BaseMailThreadAllOfParties',
        :'drafts_parties' => :'Array<Object>',
        :'folders' => :'Array<String>',
        :'version' => :'Float',
        :'snippet_draft' => :'String',
        :'snippet_sent' => :'String',
        :'message_count' => :'Integer',
        :'has_draft_flag' => :'NumberBooleanDefault0',
        :'has_sent_flag' => :'NumberBooleanDefault0',
        :'archived_flag' => :'NumberBoolean',
        :'shared_flag' => :'NumberBooleanDefault0',
        :'external_deleted_flag' => :'NumberBooleanDefault0',
        :'first_message_to_me_flag' => :'NumberBooleanDefault0',
        :'last_message_timestamp' => :'DateTime',
        :'first_message_timestamp' => :'DateTime',
        :'last_message_sent_timestamp' => :'DateTime',
        :'last_message_received_timestamp' => :'DateTime',
        :'add_time' => :'DateTime',
        :'update_time' => :'DateTime',
        :'deal_id' => :'Integer',
        :'deal_status' => :'String',
        :'all_messages_sent_flag' => :'NumberBooleanDefault0'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'snippet_draft',
        :'last_message_sent_timestamp',
        :'deal_id',
        :'deal_status',
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Pipedrive::BaseMailThreadAllOf` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Pipedrive::BaseMailThreadAllOf`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'parties')
        self.parties = attributes[:'parties']
      end

      if attributes.key?(:'drafts_parties')
        if (value = attributes[:'drafts_parties']).is_a?(Array)
          self.drafts_parties = value
        end
      end

      if attributes.key?(:'folders')
        if (value = attributes[:'folders']).is_a?(Array)
          self.folders = value
        end
      end

      if attributes.key?(:'version')
        self.version = attributes[:'version']
      end

      if attributes.key?(:'snippet_draft')
        self.snippet_draft = attributes[:'snippet_draft']
      end

      if attributes.key?(:'snippet_sent')
        self.snippet_sent = attributes[:'snippet_sent']
      end

      if attributes.key?(:'message_count')
        self.message_count = attributes[:'message_count']
      end

      if attributes.key?(:'has_draft_flag')
        self.has_draft_flag = attributes[:'has_draft_flag']
      end

      if attributes.key?(:'has_sent_flag')
        self.has_sent_flag = attributes[:'has_sent_flag']
      end

      if attributes.key?(:'archived_flag')
        self.archived_flag = attributes[:'archived_flag']
      end

      if attributes.key?(:'shared_flag')
        self.shared_flag = attributes[:'shared_flag']
      end

      if attributes.key?(:'external_deleted_flag')
        self.external_deleted_flag = attributes[:'external_deleted_flag']
      end

      if attributes.key?(:'first_message_to_me_flag')
        self.first_message_to_me_flag = attributes[:'first_message_to_me_flag']
      end

      if attributes.key?(:'last_message_timestamp')
        self.last_message_timestamp = attributes[:'last_message_timestamp']
      end

      if attributes.key?(:'first_message_timestamp')
        self.first_message_timestamp = attributes[:'first_message_timestamp']
      end

      if attributes.key?(:'last_message_sent_timestamp')
        self.last_message_sent_timestamp = attributes[:'last_message_sent_timestamp']
      end

      if attributes.key?(:'last_message_received_timestamp')
        self.last_message_received_timestamp = attributes[:'last_message_received_timestamp']
      end

      if attributes.key?(:'add_time')
        self.add_time = attributes[:'add_time']
      end

      if attributes.key?(:'update_time')
        self.update_time = attributes[:'update_time']
      end

      if attributes.key?(:'deal_id')
        self.deal_id = attributes[:'deal_id']
      end

      if attributes.key?(:'deal_status')
        self.deal_status = attributes[:'deal_status']
      end

      if attributes.key?(:'all_messages_sent_flag')
        self.all_messages_sent_flag = attributes[:'all_messages_sent_flag']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          parties == o.parties &&
          drafts_parties == o.drafts_parties &&
          folders == o.folders &&
          version == o.version &&
          snippet_draft == o.snippet_draft &&
          snippet_sent == o.snippet_sent &&
          message_count == o.message_count &&
          has_draft_flag == o.has_draft_flag &&
          has_sent_flag == o.has_sent_flag &&
          archived_flag == o.archived_flag &&
          shared_flag == o.shared_flag &&
          external_deleted_flag == o.external_deleted_flag &&
          first_message_to_me_flag == o.first_message_to_me_flag &&
          last_message_timestamp == o.last_message_timestamp &&
          first_message_timestamp == o.first_message_timestamp &&
          last_message_sent_timestamp == o.last_message_sent_timestamp &&
          last_message_received_timestamp == o.last_message_received_timestamp &&
          add_time == o.add_time &&
          update_time == o.update_time &&
          deal_id == o.deal_id &&
          deal_status == o.deal_status &&
          all_messages_sent_flag == o.all_messages_sent_flag
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [parties, drafts_parties, folders, version, snippet_draft, snippet_sent, message_count, has_draft_flag, has_sent_flag, archived_flag, shared_flag, external_deleted_flag, first_message_to_me_flag, last_message_timestamp, first_message_timestamp, last_message_sent_timestamp, last_message_received_timestamp, add_time, update_time, deal_id, deal_status, all_messages_sent_flag].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Pipedrive.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
