=begin
#Pipedrive API v1

#No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module Pipedrive
  class BaseUserMe
    # The User ID
    attr_accessor :id

    # The User name
    attr_accessor :name

    # The User default currency
    attr_accessor :default_currency

    # The User locale
    attr_accessor :locale

    # The User language ID
    attr_accessor :lang

    # The User email
    attr_accessor :email

    # The User phone
    attr_accessor :phone

    # Boolean that indicates if the User is activated
    attr_accessor :activated

    # The User last login date and time. Format: YYYY-MM-DD HH:MM:SS
    attr_accessor :last_login

    # The User creation date and time. Format: YYYY-MM-DD HH:MM:SS
    attr_accessor :created

    # The User last modification date and time. Format: YYYY-MM-DD HH:MM:SS
    attr_accessor :modified

    # The variation of signup flow (if exists). E.g. google
    attr_accessor :signup_flow_variation

    # Boolean that indicates if the User has created a Company
    attr_accessor :has_created_company

    # Indication if the User is admin (1 = true, 0 = false)
    attr_accessor :is_admin

    # Boolean that indicates if the User is activated
    attr_accessor :active_flag

    # The User timezone name
    attr_accessor :timezone_name

    # The User timezone offset
    attr_accessor :timezone_offset

    # The ID of the User role
    attr_accessor :role_id

    # The User icon URL
    attr_accessor :icon_url

    # Boolean that indicates if the requested User is the same which is logged in (in this case, always true)
    attr_accessor :is_you

    # The User company ID
    attr_accessor :company_id

    # The User company name
    attr_accessor :company_name

    # The User company domain
    attr_accessor :company_domain

    # The User company country
    attr_accessor :company_country

    # The User company industry
    attr_accessor :company_industry

    attr_accessor :language

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'name' => :'name',
        :'default_currency' => :'default_currency',
        :'locale' => :'locale',
        :'lang' => :'lang',
        :'email' => :'email',
        :'phone' => :'phone',
        :'activated' => :'activated',
        :'last_login' => :'last_login',
        :'created' => :'created',
        :'modified' => :'modified',
        :'signup_flow_variation' => :'signup_flow_variation',
        :'has_created_company' => :'has_created_company',
        :'is_admin' => :'is_admin',
        :'active_flag' => :'active_flag',
        :'timezone_name' => :'timezone_name',
        :'timezone_offset' => :'timezone_offset',
        :'role_id' => :'role_id',
        :'icon_url' => :'icon_url',
        :'is_you' => :'is_you',
        :'company_id' => :'company_id',
        :'company_name' => :'company_name',
        :'company_domain' => :'company_domain',
        :'company_country' => :'company_country',
        :'company_industry' => :'company_industry',
        :'language' => :'language'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'id' => :'Integer',
        :'name' => :'String',
        :'default_currency' => :'String',
        :'locale' => :'String',
        :'lang' => :'Integer',
        :'email' => :'String',
        :'phone' => :'String',
        :'activated' => :'Boolean',
        :'last_login' => :'String',
        :'created' => :'String',
        :'modified' => :'String',
        :'signup_flow_variation' => :'String',
        :'has_created_company' => :'Boolean',
        :'is_admin' => :'NumberBoolean',
        :'active_flag' => :'Boolean',
        :'timezone_name' => :'String',
        :'timezone_offset' => :'String',
        :'role_id' => :'Integer',
        :'icon_url' => :'String',
        :'is_you' => :'Boolean',
        :'company_id' => :'Integer',
        :'company_name' => :'String',
        :'company_domain' => :'String',
        :'company_country' => :'String',
        :'company_industry' => :'String',
        :'language' => :'BaseUserMeAllOfLanguage'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'signup_flow_variation',
        :'icon_url',
      ])
    end

    # List of class defined in allOf (OpenAPI v3)
    def self.openapi_all_of
      [
      :'BaseUser',
      :'BaseUserMeAllOf'
      ]
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Pipedrive::BaseUserMe` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Pipedrive::BaseUserMe`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'default_currency')
        self.default_currency = attributes[:'default_currency']
      end

      if attributes.key?(:'locale')
        self.locale = attributes[:'locale']
      end

      if attributes.key?(:'lang')
        self.lang = attributes[:'lang']
      end

      if attributes.key?(:'email')
        self.email = attributes[:'email']
      end

      if attributes.key?(:'phone')
        self.phone = attributes[:'phone']
      end

      if attributes.key?(:'activated')
        self.activated = attributes[:'activated']
      end

      if attributes.key?(:'last_login')
        self.last_login = attributes[:'last_login']
      end

      if attributes.key?(:'created')
        self.created = attributes[:'created']
      end

      if attributes.key?(:'modified')
        self.modified = attributes[:'modified']
      end

      if attributes.key?(:'signup_flow_variation')
        self.signup_flow_variation = attributes[:'signup_flow_variation']
      end

      if attributes.key?(:'has_created_company')
        self.has_created_company = attributes[:'has_created_company']
      end

      if attributes.key?(:'is_admin')
        self.is_admin = attributes[:'is_admin']
      end

      if attributes.key?(:'active_flag')
        self.active_flag = attributes[:'active_flag']
      end

      if attributes.key?(:'timezone_name')
        self.timezone_name = attributes[:'timezone_name']
      end

      if attributes.key?(:'timezone_offset')
        self.timezone_offset = attributes[:'timezone_offset']
      end

      if attributes.key?(:'role_id')
        self.role_id = attributes[:'role_id']
      end

      if attributes.key?(:'icon_url')
        self.icon_url = attributes[:'icon_url']
      end

      if attributes.key?(:'is_you')
        self.is_you = attributes[:'is_you']
      end

      if attributes.key?(:'company_id')
        self.company_id = attributes[:'company_id']
      end

      if attributes.key?(:'company_name')
        self.company_name = attributes[:'company_name']
      end

      if attributes.key?(:'company_domain')
        self.company_domain = attributes[:'company_domain']
      end

      if attributes.key?(:'company_country')
        self.company_country = attributes[:'company_country']
      end

      if attributes.key?(:'company_industry')
        self.company_industry = attributes[:'company_industry']
      end

      if attributes.key?(:'language')
        self.language = attributes[:'language']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          name == o.name &&
          default_currency == o.default_currency &&
          locale == o.locale &&
          lang == o.lang &&
          email == o.email &&
          phone == o.phone &&
          activated == o.activated &&
          last_login == o.last_login &&
          created == o.created &&
          modified == o.modified &&
          signup_flow_variation == o.signup_flow_variation &&
          has_created_company == o.has_created_company &&
          is_admin == o.is_admin &&
          active_flag == o.active_flag &&
          timezone_name == o.timezone_name &&
          timezone_offset == o.timezone_offset &&
          role_id == o.role_id &&
          icon_url == o.icon_url &&
          is_you == o.is_you &&
          company_id == o.company_id &&
          company_name == o.company_name &&
          company_domain == o.company_domain &&
          company_country == o.company_country &&
          company_industry == o.company_industry &&
          language == o.language
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [id, name, default_currency, locale, lang, email, phone, activated, last_login, created, modified, signup_flow_variation, has_created_company, is_admin, active_flag, timezone_name, timezone_offset, role_id, icon_url, is_you, company_id, company_name, company_domain, company_country, company_industry, language].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Pipedrive.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
