=begin
#Pipedrive API v1

#No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module Pipedrive
  class InlineObject33
    # A full, valid, publicly accessible URL. Determines where to send the notifications. Please note that you cannot use Pipedrive API endpoints as the subscription_url.
    attr_accessor :subscription_url

    # Type of action to receive notifications about. Wildcard will match all supported actions.
    attr_accessor :event_action

    # Type of object to receive notifications about. Wildcard will match all supported objects.
    attr_accessor :event_object

    # The ID of the user this webhook will be authorized with. If not set, current authorized user will be used. Note that this does not filter only certain user's events — rather, this specifies the user's permissions under which each event is checked. Events about objects the selected user is not entitled to access are not sent. If you want to receive notifications for all events, a top-level admin user should be used.
    attr_accessor :user_id

    # HTTP basic auth username of the subscription URL endpoint (if required).
    attr_accessor :http_auth_user

    # HTTP basic auth password of the subscription URL endpoint (if required).
    attr_accessor :http_auth_password

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'subscription_url' => :'subscription_url',
        :'event_action' => :'event_action',
        :'event_object' => :'event_object',
        :'user_id' => :'user_id',
        :'http_auth_user' => :'http_auth_user',
        :'http_auth_password' => :'http_auth_password'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'subscription_url' => :'String',
        :'event_action' => :'String',
        :'event_object' => :'String',
        :'user_id' => :'Integer',
        :'http_auth_user' => :'String',
        :'http_auth_password' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Pipedrive::InlineObject33` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Pipedrive::InlineObject33`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'subscription_url')
        self.subscription_url = attributes[:'subscription_url']
      end

      if attributes.key?(:'event_action')
        self.event_action = attributes[:'event_action']
      end

      if attributes.key?(:'event_object')
        self.event_object = attributes[:'event_object']
      end

      if attributes.key?(:'user_id')
        self.user_id = attributes[:'user_id']
      end

      if attributes.key?(:'http_auth_user')
        self.http_auth_user = attributes[:'http_auth_user']
      end

      if attributes.key?(:'http_auth_password')
        self.http_auth_password = attributes[:'http_auth_password']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @subscription_url.nil?
        invalid_properties.push('invalid value for "subscription_url", subscription_url cannot be nil.')
      end

      if @event_action.nil?
        invalid_properties.push('invalid value for "event_action", event_action cannot be nil.')
      end

      if @event_object.nil?
        invalid_properties.push('invalid value for "event_object", event_object cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @subscription_url.nil?
      return false if @event_action.nil?
      event_action_validator = EnumAttributeValidator.new('String', ["added", "updated", "merged", "deleted", "*"])
      return false unless event_action_validator.valid?(@event_action)
      return false if @event_object.nil?
      event_object_validator = EnumAttributeValidator.new('String', ["activity", "activityType", "deal", "note", "organization", "person", "pipeline", "product", "stage", "user", "*"])
      return false unless event_object_validator.valid?(@event_object)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] event_action Object to be assigned
    def event_action=(event_action)
      validator = EnumAttributeValidator.new('String', ["added", "updated", "merged", "deleted", "*"])
      unless validator.valid?(event_action)
        fail ArgumentError, "invalid value for \"event_action\", must be one of #{validator.allowable_values}."
      end
      @event_action = event_action
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] event_object Object to be assigned
    def event_object=(event_object)
      validator = EnumAttributeValidator.new('String', ["activity", "activityType", "deal", "note", "organization", "person", "pipeline", "product", "stage", "user", "*"])
      unless validator.valid?(event_object)
        fail ArgumentError, "invalid value for \"event_object\", must be one of #{validator.allowable_values}."
      end
      @event_object = event_object
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          subscription_url == o.subscription_url &&
          event_action == o.event_action &&
          event_object == o.event_object &&
          user_id == o.user_id &&
          http_auth_user == o.http_auth_user &&
          http_auth_password == o.http_auth_password
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [subscription_url, event_action, event_object, user_id, http_auth_user, http_auth_password].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Pipedrive.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
