=begin
#Pipedrive API v1

#No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module Pipedrive
  class ProductField
    # Name of the field
    attr_accessor :name

    # When field_type is either set or enum, possible options must be supplied as a JSON-encoded sequential array, for example: [\"red\",\"blue\",\"lilac\"]
    attr_accessor :options

    # Type of the field.<dl class=\"fields-list\"><dt>varchar</dt><dd>Text (up to 255 characters)</dd><dt>varchar_auto</dt><dd>Autocomplete text (up to 255 characters)</dd><dt>text</dt><dd>Long text (up to 65k characters)</dd><dt>double</dt><dd>Numeric value</dd><dt>monetary</dt><dd>Monetary field (has a numeric value and a currency value)</dd><dt>date</dt><dd>Date (format YYYY-MM-DD)</dd><dt>set</dt><dd>Options field with a possibility of having multiple chosen options</dd><dt>enum</dt><dd>Options field with a single possible chosen option</dd><dt>user</dt><dd>User field (contains a user ID of another Pipedrive user)</dd><dt>org</dt><dd>Organization field (contains an organization ID which is stored on the same account)</dd><dt>people</dt><dd>Person field (contains a product ID which is stored on the same account)</dd><dt>phone</dt><dd>Phone field (up to 255 numbers and/or characters)</dd><dt>time</dt><dd>Time field (format HH:MM:SS)</dd><dt>timerange</dt><dd>Time-range field (has a start time and end time value, both HH:MM:SS)</dd><dt>daterange</dt><dd>Date-range field (has a start date and end date value, both YYYY-MM-DD)</dd><dt>address</dt><dd>Address field (autocompleted by Google Maps)</dd></dl>
    attr_accessor :field_type

    # The ID of the Product Field
    attr_accessor :id

    # The key of the Product Field
    attr_accessor :key

    # Position (index) of the Product Field in the detail view
    attr_accessor :order_nr

    # The Product Field creation time. Format: YYYY-MM-DD HH:MM:SS
    attr_accessor :add_time

    # The Product Field last update time. Format: YYYY-MM-DD HH:MM:SS
    attr_accessor :update_time

    # The ID of the last user to update the Product Field
    attr_accessor :last_updated_by_user_id

    # Whether or not the Product Field is currently active
    attr_accessor :active_flag

    # Whether or not the Product Field Name and metadata is editable
    attr_accessor :edit_flag

    # Whether or not the Product Field is visible in the Add Product Modal
    attr_accessor :add_visible_flag

    # Whether or not the Product Field is marked as important
    attr_accessor :important_flag

    # Whether or not the Product Field data can be edited
    attr_accessor :bulk_edit_allowed

    # Whether or not the Product Field is searchable
    attr_accessor :searchable_flag

    # Whether or not the Product Field value can be used when filtering searches
    attr_accessor :filtering_allowed

    # Whether or not the Product Field is sortable
    attr_accessor :sortable_flag

    # Whether or not the Product Field is mandatory when creating products
    attr_accessor :mandatory_flag

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'name' => :'name',
        :'options' => :'options',
        :'field_type' => :'field_type',
        :'id' => :'id',
        :'key' => :'key',
        :'order_nr' => :'order_nr',
        :'add_time' => :'add_time',
        :'update_time' => :'update_time',
        :'last_updated_by_user_id' => :'last_updated_by_user_id',
        :'active_flag' => :'active_flag',
        :'edit_flag' => :'edit_flag',
        :'add_visible_flag' => :'add_visible_flag',
        :'important_flag' => :'important_flag',
        :'bulk_edit_allowed' => :'bulk_edit_allowed',
        :'searchable_flag' => :'searchable_flag',
        :'filtering_allowed' => :'filtering_allowed',
        :'sortable_flag' => :'sortable_flag',
        :'mandatory_flag' => :'mandatory_flag'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'name' => :'String',
        :'options' => :'Array<Object>',
        :'field_type' => :'String',
        :'id' => :'Integer',
        :'key' => :'String',
        :'order_nr' => :'Integer',
        :'add_time' => :'String',
        :'update_time' => :'String',
        :'last_updated_by_user_id' => :'Integer',
        :'active_flag' => :'Boolean',
        :'edit_flag' => :'Boolean',
        :'add_visible_flag' => :'Boolean',
        :'important_flag' => :'Boolean',
        :'bulk_edit_allowed' => :'Boolean',
        :'searchable_flag' => :'Boolean',
        :'filtering_allowed' => :'Boolean',
        :'sortable_flag' => :'Boolean',
        :'mandatory_flag' => :'Boolean'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # List of class defined in allOf (OpenAPI v3)
    def self.openapi_all_of
      [
      :'NewProductField',
      :'ProductFieldAllOf'
      ]
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Pipedrive::ProductField` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Pipedrive::ProductField`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'options')
        if (value = attributes[:'options']).is_a?(Array)
          self.options = value
        end
      end

      if attributes.key?(:'field_type')
        self.field_type = attributes[:'field_type']
      end

      if attributes.key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.key?(:'key')
        self.key = attributes[:'key']
      end

      if attributes.key?(:'order_nr')
        self.order_nr = attributes[:'order_nr']
      end

      if attributes.key?(:'add_time')
        self.add_time = attributes[:'add_time']
      end

      if attributes.key?(:'update_time')
        self.update_time = attributes[:'update_time']
      end

      if attributes.key?(:'last_updated_by_user_id')
        self.last_updated_by_user_id = attributes[:'last_updated_by_user_id']
      end

      if attributes.key?(:'active_flag')
        self.active_flag = attributes[:'active_flag']
      end

      if attributes.key?(:'edit_flag')
        self.edit_flag = attributes[:'edit_flag']
      end

      if attributes.key?(:'add_visible_flag')
        self.add_visible_flag = attributes[:'add_visible_flag']
      end

      if attributes.key?(:'important_flag')
        self.important_flag = attributes[:'important_flag']
      end

      if attributes.key?(:'bulk_edit_allowed')
        self.bulk_edit_allowed = attributes[:'bulk_edit_allowed']
      end

      if attributes.key?(:'searchable_flag')
        self.searchable_flag = attributes[:'searchable_flag']
      end

      if attributes.key?(:'filtering_allowed')
        self.filtering_allowed = attributes[:'filtering_allowed']
      end

      if attributes.key?(:'sortable_flag')
        self.sortable_flag = attributes[:'sortable_flag']
      end

      if attributes.key?(:'mandatory_flag')
        self.mandatory_flag = attributes[:'mandatory_flag']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @field_type.nil?
        invalid_properties.push('invalid value for "field_type", field_type cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @name.nil?
      return false if @field_type.nil?
      field_type_validator = EnumAttributeValidator.new('String', ["varchar", "varchar_auto", "text", "double", "monetary", "date", "set", "enum", "user", "org", "people", "phone", "time", "timerange", "daterange", "address"])
      return false unless field_type_validator.valid?(@field_type)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] field_type Object to be assigned
    def field_type=(field_type)
      validator = EnumAttributeValidator.new('String', ["varchar", "varchar_auto", "text", "double", "monetary", "date", "set", "enum", "user", "org", "people", "phone", "time", "timerange", "daterange", "address"])
      unless validator.valid?(field_type)
        fail ArgumentError, "invalid value for \"field_type\", must be one of #{validator.allowable_values}."
      end
      @field_type = field_type
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          name == o.name &&
          options == o.options &&
          field_type == o.field_type &&
          id == o.id &&
          key == o.key &&
          order_nr == o.order_nr &&
          add_time == o.add_time &&
          update_time == o.update_time &&
          last_updated_by_user_id == o.last_updated_by_user_id &&
          active_flag == o.active_flag &&
          edit_flag == o.edit_flag &&
          add_visible_flag == o.add_visible_flag &&
          important_flag == o.important_flag &&
          bulk_edit_allowed == o.bulk_edit_allowed &&
          searchable_flag == o.searchable_flag &&
          filtering_allowed == o.filtering_allowed &&
          sortable_flag == o.sortable_flag &&
          mandatory_flag == o.mandatory_flag
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [name, options, field_type, id, key, order_nr, add_time, update_time, last_updated_by_user_id, active_flag, edit_flag, add_visible_flag, important_flag, bulk_edit_allowed, searchable_flag, filtering_allowed, sortable_flag, mandatory_flag].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Pipedrive.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
