=begin
#Pipedrive API v1

#No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module Pipedrive
  class UserSettingsItem
    # If the vendors are allowed to install custom Marketplace apps with functionality and content in the Pipedrive UI or not
    attr_accessor :marketplace_allow_custom_install_url

    # If the vendors are allowed to extend their Marketplace apps with functionality and content in the Pipedrive UI or not
    attr_accessor :marketplace_app_extensions_vendor

    # If the vendors are allowed to be part of the Marketplace team or not
    attr_accessor :marketplace_team

    # Number of results shown in list by default
    attr_accessor :list_limit

    # If beta app is enabled
    attr_accessor :beta_app

    # Prevent salesphone call to override
    attr_accessor :prevent_salesphone_callto_override

    # The destination of File upload
    attr_accessor :file_upload_destination

    # The call to link syntax
    attr_accessor :callto_link_syntax

    # If the expected close date of the Deal is filled automatically or not
    attr_accessor :autofill_deal_expected_close_date

    # Allow the vendors to duplicate a Person
    attr_accessor :person_duplicate_condition

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'marketplace_allow_custom_install_url' => :'marketplace_allow_custom_install_url',
        :'marketplace_app_extensions_vendor' => :'marketplace_app_extensions_vendor',
        :'marketplace_team' => :'marketplace_team',
        :'list_limit' => :'list_limit',
        :'beta_app' => :'beta_app',
        :'prevent_salesphone_callto_override' => :'prevent_salesphone_callto_override',
        :'file_upload_destination' => :'file_upload_destination',
        :'callto_link_syntax' => :'callto_link_syntax',
        :'autofill_deal_expected_close_date' => :'autofill_deal_expected_close_date',
        :'person_duplicate_condition' => :'person_duplicate_condition'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'marketplace_allow_custom_install_url' => :'Boolean',
        :'marketplace_app_extensions_vendor' => :'Boolean',
        :'marketplace_team' => :'Boolean',
        :'list_limit' => :'Float',
        :'beta_app' => :'Boolean',
        :'prevent_salesphone_callto_override' => :'Boolean',
        :'file_upload_destination' => :'String',
        :'callto_link_syntax' => :'String',
        :'autofill_deal_expected_close_date' => :'Boolean',
        :'person_duplicate_condition' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Pipedrive::UserSettingsItem` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Pipedrive::UserSettingsItem`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'marketplace_allow_custom_install_url')
        self.marketplace_allow_custom_install_url = attributes[:'marketplace_allow_custom_install_url']
      end

      if attributes.key?(:'marketplace_app_extensions_vendor')
        self.marketplace_app_extensions_vendor = attributes[:'marketplace_app_extensions_vendor']
      end

      if attributes.key?(:'marketplace_team')
        self.marketplace_team = attributes[:'marketplace_team']
      end

      if attributes.key?(:'list_limit')
        self.list_limit = attributes[:'list_limit']
      end

      if attributes.key?(:'beta_app')
        self.beta_app = attributes[:'beta_app']
      end

      if attributes.key?(:'prevent_salesphone_callto_override')
        self.prevent_salesphone_callto_override = attributes[:'prevent_salesphone_callto_override']
      end

      if attributes.key?(:'file_upload_destination')
        self.file_upload_destination = attributes[:'file_upload_destination']
      end

      if attributes.key?(:'callto_link_syntax')
        self.callto_link_syntax = attributes[:'callto_link_syntax']
      end

      if attributes.key?(:'autofill_deal_expected_close_date')
        self.autofill_deal_expected_close_date = attributes[:'autofill_deal_expected_close_date']
      end

      if attributes.key?(:'person_duplicate_condition')
        self.person_duplicate_condition = attributes[:'person_duplicate_condition']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          marketplace_allow_custom_install_url == o.marketplace_allow_custom_install_url &&
          marketplace_app_extensions_vendor == o.marketplace_app_extensions_vendor &&
          marketplace_team == o.marketplace_team &&
          list_limit == o.list_limit &&
          beta_app == o.beta_app &&
          prevent_salesphone_callto_override == o.prevent_salesphone_callto_override &&
          file_upload_destination == o.file_upload_destination &&
          callto_link_syntax == o.callto_link_syntax &&
          autofill_deal_expected_close_date == o.autofill_deal_expected_close_date &&
          person_duplicate_condition == o.person_duplicate_condition
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [marketplace_allow_custom_install_url, marketplace_app_extensions_vendor, marketplace_team, list_limit, beta_app, prevent_salesphone_callto_override, file_upload_destination, callto_link_syntax, autofill_deal_expected_close_date, person_duplicate_condition].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Pipedrive.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
